﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace NMigrate
{
	public abstract class Configuration<T> : Configuration where T : class
	{
		public abstract T GetValue();

		#region Configuration Members

		object Configuration.GetValue()
		{
			return GetValue();
		}

		U Configuration.GetValue<U>()
		{
			return GetValue() as U;
		}

		#endregion
	}
	public interface Configuration
	{
		object GetValue();
		T GetValue<T>() where T : class;
	}
}
